From f6292378c714cd727e31bf6fc22d1233305ca4c1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 02 2020 05:09:11 +0000
Subject: [PATCH 87/2232] Add rust::Box member type aliases


---

diff --git a/gen/write.rs b/gen/write.rs
index e0396c9..e6fb4e9 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -79,6 +79,7 @@ pub(super) fn gen(namespace: Vec<String>, apis: &[Api], types: &Types, header: b
 
 fn write_includes(out: &mut OutFile, types: &Types) {
     let mut has_int = false;
+    let mut has_box = false;
     let mut has_unique_ptr = false;
     let mut has_string = false;
 
@@ -90,6 +91,7 @@ fn write_includes(out: &mut OutFile, types: &Types) {
                 Some(CxxString) => has_string = true,
                 Some(Bool) | Some(RustString) | None => {}
             },
+            Type::RustBox(_) => has_box = true,
             Type::UniquePtr(_) => has_unique_ptr = true,
             _ => {}
         }
@@ -104,6 +106,9 @@ fn write_includes(out: &mut OutFile, types: &Types) {
     if has_string {
         writeln!(out, "#include <string>");
     }
+    if has_box {
+        writeln!(out, "#include <type_traits>");
+    }
 }
 
 fn write_include_cxxbridge(out: &mut OutFile, types: &Types) {
diff --git a/include/cxxbridge.h b/include/cxxbridge.h
index 984eca2..fe2f5be 100644
--- a/include/cxxbridge.h
+++ b/include/cxxbridge.h
@@ -3,6 +3,7 @@
 #include <cstdint>
 #include <iosfwd>
 #include <string>
+#include <type_traits>
 
 namespace rust {
 inline namespace cxxbridge01 {
@@ -69,6 +70,10 @@ private:
 #define CXXBRIDGE01_RUST_BOX
 template <typename T> class Box final {
 public:
+  using value_type = T;
+  using const_pointer = std::add_pointer_t<std::add_const_t<value_type>>;
+  using pointer = std::add_pointer_t<value_type>;
+
   Box(const Box &other) : Box(*other) {}
   Box(Box &&other) noexcept : repr(other.repr) { other.repr = 0; }
   Box(const T &val) {

